;*** ASCTOBIN.M
;*** AUTOMGEN V5
;*** (C)opyright 1994 IRAI
;*** 29/07/1992
;***
;*** Conversion ascii(hexadcimal) vers binaire
;*** {?0} & {?1} mots d'entres en ascii
;*** {?2} mot de sortie en binaire
;*** l'accumulateur contient $ffff en cas d'erreur ou 0 autrement
;***
;*** Ordre :
;*** {?0} contiendra les poids forts (deux premiers digits)
;*** {?1} contiendra les poids faibles (deux derniers digits)
;***
;*** Exemple:
;*** si {?0}="AB" et {?1}="12" alors {?2}=$AB12
;***
;*** Attention: les mots m59 et m58 sont utiliss pour les calculs
;*** ---------  intermdiaires.










        lda {?0}
        sta m120
        lda {?1}
        sta m121
      	res m123
        ; premier digit
        lda m120
        ana %1111111100000000
        rra 8
        sta m59
        jmp :asctobin-converta1: and m59>47 and m59<58
        jmp :asctobin-converta2: and m59>64 and m59<71
        set m123
        res aaa
        jmp :asctobin-converta3:
:asctobin-converta2:
        sba 55
        jmp :asctobin-converta3:
:asctobin-converta1:
        sba 48

:asctobin-converta3:
        sta m59
        rla 12
        sta m58
        ; deuxime digit
        lda m120
        ana %0000000011111111

        sta m59
        jmp :asctobin-convertb1: and m59>47 and m59<58
        jmp :asctobin-convertb2: and m59>64 and m59<71
        set m123
        res aaa
        jmp :asctobin-convertb3:
:asctobin-convertb2:
        sba 55
        jmp :asctobin-convertb3:
:asctobin-convertb1:
        sba 48
:asctobin-convertb3:
        sta m59

        rla 8
        ora m58
        sta m58
        ; troisime digit
        lda m121
        ana %1111111100000000
        rla 8
        sta m59
        jmp :asctobin-convertc1: and m59>47 and m59<58
        jmp :asctobin-convertc2: and m59>64 and m59<71
        set m123
        res aaa
        jmp :asctobin-convertc3:
:asctobin-convertc2:
        sba 55
        jmp :asctobin-convertc3:
:asctobin-convertc1:
        sba 48
:asctobin-convertc3:
        sta m59
        rla 4
        ora m58
        sta m58
        ; quatrime digit
        lda m121
        ana %0000000011111111
        sta m59
        jmp :asctobin-convertd1: and m59>47 and m59<58
        jmp :asctobin-convertd2: and m59>64 and m59<71
        set m123
        res aaa
        jmp :asctobin-convertd3:
:asctobin-convertd2:
        sba 55
        jmp :asctobin-convertd3:
:asctobin-convertd1:
        sba 48
:asctobin-convertd3:
        sta m59
        ora m58
        res aaa and m123!0
        sta m122
        lda m122
        sta {?2}
        lda m123


